function FileToUpload(elm, file, id){
	this.element = elm;
	this.fileName = file;
	this.identifier = id;
}

var countUpFiles = 0;
var filesToUpload;
var currentFileUpload = 0;
var keepUploading = false;
var uploadMode;
var executingCmd;
var selectedIdx;
var selectedIndexes;
var upReady;
function sortTable(field, order){
	window.location.href = '/browse?path=' + currentPath + '&sfield=' + field + '&sorder=' + order + ((curThumbs != '' && curThumbs == 'y') ? '&thumbs=y' : '');
}
function addFile(includeRemoveImg, fromCancel){
	countUpFiles++;
	if(!fromCancel || uploadMode == 'n'){
		var uploadFile = document.createElement('div');
		uploadFile.style.paddingTop = '5px';
		uploadFile.innerHTML = generateFileUpload(includeRemoveImg);
		var uploadDiv = document.getElementById('fileuplist');
		uploadDiv.appendChild(uploadFile);
	}
	else{
		var zipFileInput = generateFileUpload(false);
		var uploadDiv = document.getElementById('zipctner');
		uploadDiv.innerHTML = zipFileInput;
	}
}
function generateFileUpload(includeRemoveImg){
	var removeImg = '';
	if(includeRemoveImg){
		removeImg = '<img class="imgremove" src="/imgs?img=remove.png" alt="" onclick="removeFile(this)" />';
	}
	var inputId = '';
	if(uploadMode == 'z'){
		inputId = 'id="zipfile" ';
	}
	return '<input type="file" ' + inputId + 'name="upfile' + countUpFiles + '" />' + removeImg;
}
function removeFile(elm){
	var uploadFile = elm.parentNode;
	var uploadDiv = document.getElementById('fileuplist');
	uploadDiv.removeChild(uploadFile);
}
function uploadFiles(){
	filesToUpload = new Array();
	var uploadDiv = document.getElementById('fileuplist');
	var childs = uploadDiv.childNodes;
	if(childs && childs.length > 0){
		var length = childs.length;
		for (var i=0; i<length; i++){
			var elmName = childs[i].tagName;
			if(elmName && elmName.length > 0){
				elmName = elmName.toLowerCase();
				if(elmName == 'div'){
					var upFileChilds = childs[i].childNodes;
					if(upFileChilds && upFileChilds.length > 0){
						var lengthChilds = upFileChilds.length;
						for (var j=0; j<lengthChilds; j++){
							elmName = upFileChilds[j].tagName;
							if(elmName && elmName.length > 0){
								elmName = elmName.toLowerCase();
								if(elmName == 'input'){
									if(upFileChilds[j].value && upFileChilds[j].value.length > 0){
										
										var fileToUpload = new FileToUpload(childs[i], getFileName(upFileChilds[j].value), generateUpIdentifier());
										filesToUpload[filesToUpload.length] = fileToUpload;
									}
									break;
								}
								
							}
						}
					}
				}
			}
		}
		
	}
	if(filesToUpload.length > 0){
		uploadMode = 'n';
		prepareUpload(uploadDiv);
		upReady = true;
		startUpload();
	}
	else{
		alert('Please select files to upload.');
	}
}
function uploadZipFile(){
	filesToUpload = new Array();
	var zip = document.getElementById('zipfile');
	if(zip){
		if(zip.value && zip.value.length > 0){
			var fileToUpload = new FileToUpload(zip, getFileName(zip.value), generateUpIdentifier());
			filesToUpload[filesToUpload.length] = fileToUpload;
			var uploadDiv = document.getElementById('zipctner');
			uploadMode = 'z';
			prepareUpload(uploadDiv);
			upReady = true;
			startUpload();
		}
		else{
			alert('Please select a zip file to upload.');
		}
	}
}
function prepareUpload(uploadDiv){
	if(uploadMode == 'n'){
		setPopTitle('Uploading files');
	}
	else{
		setPopTitle('Uploading zip file');
	}
	clearChilds('popcont', null);
	
	showGray();
	
	var popCont = document.getElementById('popcont'); 
	var length = filesToUpload.length;
	popCont.innerHTML = '';
	for(var i=0; i<length; i++){
		popCont.innerHTML += generateUpHtml(filesToUpload[i].fileName, filesToUpload[i].identifier);
	}
	
	addCancelBtn('cancelUpload');
	
	var popDiv = document.getElementById('popdiv');
	popDiv.style.display = '';
	
	clearChilds(null, uploadDiv);
	
	currentFileUpload = 0;
	keepUploading = true;
}
function showGray(){
	var container = document.getElementById('container');
	var grayDiv = document.getElementById('graydiv');
	grayDiv.style.height = container.offsetHeight + 'px';
	grayDiv.style.width = container.offsetWidth + 'px';
	grayDiv.style.display = '';
}
function hideGray(){
	var grayDiv = document.getElementById('graydiv');
	grayDiv.style.display = 'none';
	var popDiv = document.getElementById('popdiv');
	popDiv.style.display = 'none';
}
function getFileName(fullPath){
	var idxSlash = fullPath.lastIndexOf('/');
	var idxBackSlash = fullPath.lastIndexOf('\\');
	if(idxSlash >= 0 || idxBackSlash >=0){
		if(idxSlash > idxBackSlash){
			fullPath = fullPath.substr(idxSlash + 1);
		}
		else{
			fullPath = fullPath.substr(idxBackSlash + 1);
		}
	}
	return fullPath;
}
function setNextUpReady(){
	upReady = true;
}
function startUpload(){
	
	if(keepUploading){
		
		if(upReady){
			upReady = false;
			var chkOver = document.getElementById('chkupl');
			if(chkOver.checked){
				startFileUpload();
			}
			else{
				var currentFile = filesToUpload[currentFileUpload];
				$.get('/checkfile?path=' + currentPath + '&file=' + encodeURIComponent(currentFile.fileName) + '&m=' + Math.random(), fileCheckHdlr);
			}
		}
		else{
			setTimeout("startUpload()",1000);
		}
	}
}
function fileCheckHdlr(xml){
	var res = $("s", xml).text();
	if(res && res == 'N'){
		startFileUpload();
	}
	else{
		upReady = true;
		upStatusError('ex', filesToUpload[currentFileUpload].identifier);
		processNextFile();
	}
}
function startFileUpload(){
	var postfileForm = document.getElementById('uploadFiles');
	var currentFile = filesToUpload[currentFileUpload];
	addUploadMetaData(postfileForm, currentPathNotEnc, currentFile.identifier, currentFile.element);
	document.getElementById('upfrm').name='tframe';
	postfileForm.submit();
	refreshCurrentUpload(currentFile.identifier);
}
function addUploadMetaData(form, path, identifier, fileInput){
	clearChilds(null, form);
	
	var input = document.createElement('input');
	input.name = 'identifier';
	input.type = 'text';
	input.value = identifier;
	form.appendChild(input);
	input = document.createElement('input');
	input.name = 'path';
	input.type = 'text';
	input.value = path;
	form.appendChild(input);
	input = document.createElement('input');
	input.name = 'over';
	input.type = 'text';
	
	var chkOver;
	if(uploadMode == 'n'){
		chkOver = document.getElementById('chkupl');
	}
	else{
		chkOver = document.getElementById('chkuplzip');
	}
	if(chkOver.checked){
		input.value = 'y';
	}
	else{
		input.value = 'n';
	}
	form.appendChild(input);
	
	input = document.createElement('input');
	input.name = 'zip';
	input.type = 'text';
	input.value = uploadMode;
	form.appendChild(input);
	
	form.appendChild(fileInput);
	
}
function generateUpIdentifier(){
	var d = new Date();
	var rnd = Math.floor(Math.random() * 10001) + '';
	return d.getTime() + rnd;
}
function generateUpHtml(filename, identifier){
	var str;
	str = '<br />';
	str += '<span class="thirteen">' + filename + '</span>';
	str += '<div>';
	str += '<div style="float: left">';
	
	str += '<div class="progressbar">';
	str += '<div id="' + identifier + 'bar" style="width: 0px" class="progressbarfill">';
	str += '</div>';
	str += '</div>';
	
	str += '</div>';
	
	str += '<div style="float: left">';
	str += '<span class="thirteen" id="' + identifier + 'span"></span>';
	str += '</div>';
	
	str += '<div style="clear: both">';
	str += '</div>';
	str += '</div>';
	return str;
}
function clearChilds(elementId, element){
	var elm;
	if(element){
		elm = element;
	}
	else{
		elm = document.getElementById(elementId);
	}
	while(elm.childNodes && elm.childNodes.length > 0){
		elm.removeChild(elm.firstChild);
	}
}
function setPopTitle(title){
	var popTitle = document.getElementById('poptitle');
	popTitle.innerHTML = title;
}
function refreshCurrentUpload(identifier){
	if(keepUploading){
		$.get("/upstatus?i=" + identifier + '&m=' + Math.random(), upStatusHdlr);
	}
}
function upStatusHdlr(xml) {
	var res = $("s", xml).text();
	if(res){
		if(res == 'P'){
			var t = $("t", xml).text();
			var u = $("u", xml).text();
			if(t && u){
				upStatusInfo(filesToUpload[currentFileUpload].identifier, t, u, null);
			}
			setTimeout("refreshCurrentUpload('" + filesToUpload[currentFileUpload].identifier + "')", 100);
		}
		else if(res == 'F'){
			var t = $("t", xml).text();
			upStatusInfo(filesToUpload[currentFileUpload].identifier, t, null, 'f');
			processNextFile();
		}
		else if(res == 'X'){
			upStatusError('ex', filesToUpload[currentFileUpload].identifier);
			processNextFile();
		}
		else if(res == 'E'){
			upStatusError('err', filesToUpload[currentFileUpload].identifier);
			processNextFile();
		}
		else if(res == 'EX'){
			var t = $("t", xml).text();
			upStatusInfo(filesToUpload[currentFileUpload].identifier, t, null, 'z');
			setTimeout("refreshCurrentUpload('" + filesToUpload[currentFileUpload].identifier + "')", 100);
		}
		else if(res == 'XE'){
			var t = $("t", xml).text();
			upStatusInfo(filesToUpload[currentFileUpload].identifier, t, null, 'xe');
			processNextFile();
		}
	}
}
function upStatusInfo(identifier, totalStr, uploadedStr, finished){
	var elm;
	if(finished && finished.length > 0){
		elm = document.getElementById(identifier + 'bar');
		elm.style.width = '200px';
		elm = document.getElementById(identifier + 'span');
		elm.className = 'thirteen green bold';
		if(finished == 'f' || finished == 'xe'){
			elm.innerHTML = '&nbsp;Done!&nbsp;(' + totalStr + '&nbsp;KB)';
			if(finished == 'xe'){
				alert('Some files were not extracted. Please make sure you have enough available space on your SD card. Also try to avoid using filenames with non-english characters inside your zip file.');
			}
		}
		else{
			elm.innerHTML = '&nbsp;Extracting...&nbsp;(' + totalStr + '&nbsp;KB)';
		}
	}
	else{
		total = parseInt(totalStr);
		uploaded = parseInt(uploadedStr);
		if(total > 0){
			var percentage = Math.floor((parseInt(uploaded) * 100) / total);
			var width = Math.floor((percentage * 200) / 100);
			elm = document.getElementById(identifier + 'bar');
			elm.style.width = width + 'px';
			elm = document.getElementById(identifier + 'span');
			elm.innerHTML = '&nbsp;' + percentage + '%&nbsp;(' + uploadedStr + ' / ' + totalStr + '&nbsp;KB)';
		}
	}
}
function processNextFile(){
	if(currentFileUpload < (filesToUpload.length - 1)){
		currentFileUpload++;
		if(keepUploading){
			startUpload();
		}
	}
	else{
		addCloseBtn();
	}
}
function redirFrame(){
	if(window.frames && window.frames.length > 0 && window.frames[0]){
		window.frames[0].location.href = '/upload';
	}
}
function upStatusError(type, identifier){
	var elm;
	elm = document.getElementById(identifier + 'bar');
	elm.style.width = '0px';
	elm = document.getElementById(identifier + 'span');
	elm.className = 'thirteen red bold';
	if(type == 'ex'){
		elm.innerHTML = '&nbsp;File already exists!';
	}
	else{
		elm.innerHTML = '&nbsp;Permission denied/No space left on device?';
	}
}
function addCancelBtn(closeFn){
	var btnDiv = document.getElementById('btnpopcont');
	clearChilds(null, btnDiv);
	var str = '<input type="submit" class="btn" value="Cancel" onclick="' + closeFn + '()" />';
	btnDiv.innerHTML = str;
}
function cancelUpload(){
	keepUploading = false;
	hideGray();
	addFile(false, true);
	redirFrame();
}
function addCloseBtn(){
	var btnDiv = document.getElementById('btnpopcont');
	clearChilds(null, btnDiv);
	var str = '<input type="submit" class="btn" value="Close" onclick="reloadPage()" /><span class="thirteen bold">&nbsp;Finished! Click to close this window</span>';
	btnDiv.innerHTML = str;
}
function reloadPage(){
	window.location.reload();
}
function newFolder(){
	showGray();
	setPopTitle('Create folder');
	clearChilds('popcont', null);
	var popCont = document.getElementById('popcont'); 
	popCont.innerHTML = generateDialogContentHtml('Please enter new folder name', true);
	
	addCancelBtn('hideGray');
	addOkBtn('create');
	var popDiv = document.getElementById('popdiv');
	popDiv.style.display = '';
}
function generateDialogContentHtml(msg, includeInput){
	var inputTxt = '';
	if(includeInput){
		inputTxt = '<input type="text" id="cmdtxt" /><br />';
	}
	return '<span class="thirteen bold">' + msg + '</span><br />' + inputTxt + '<span id="dlgresult"></span>';
}
function addOkBtn(cmd){
	var btnDiv = document.getElementById('btnpopcont');
	var str = '<input id="cmdbtn" type="submit" class="btn" value="Ok" onclick="execCmd(\'' + cmd + '\')" />';
	btnDiv.innerHTML += str;
}
function execCmd(cmd){
	var warnMsg;
	var reqUrl;
	executingCmd = cmd;
	if(cmd == 'delete'){
		if(selectedIndexes && selectedIndexes.length > 0){
			var btn = document.getElementById('cmdbtn');
			btn.disabled = true;
			var fileStr = '';
			var selectedFile;
			for(var i=0; i<selectedIndexes.length; i++){
				selectedFile = document.getElementById('fname' + selectedIndexes[i]);
				if(selectedFile && selectedFile.value && selectedFile.value.length > 0){
					if(i > 0){
						fileStr += encodeURIComponent('s/s');
					}
					fileStr += selectedFile.value;
				} 
			}
			if(fileStr.length > 0){
				reqUrl = '/delete';
				$.get(reqUrl + '?path=' + currentPath + '&files=' + fileStr + '&m=' + Math.random(), exexCmdHdlr);
			}
		}
	}
	else{
		if(cmd == 'create'){
			warnMsg = 'Please enter the new folder name';
			reqUrl = '/checkfolder';
		}
		else{
			warnMsg = 'Please enter the desired item new name.';
			reqUrl = '/rename';
		}
		var elm = document.getElementById('cmdtxt');
		var elmValue = elm.value;
		if(elmValue && elmValue.length > 0){
			if(elmValue.indexOf('/') >= 0){
				alert('The character \'/\' is not valid');
			}
			else{
				elmValue = encodeURIComponent(elmValue);
				var btn = document.getElementById('cmdbtn');
				btn.disabled = true;
				elm.disabled = true;
				var elmRes = document.getElementById('dlgresult');
				elmRes.innerHTML = '';
				if(cmd == 'create'){
					$.get(reqUrl + '?path=' + currentPath + '&file=' + elmValue + '&m=' + Math.random(), exexCmdHdlr);
				}
				else{
					var selectedFile = document.getElementById('fname' + selectedIdx);
					if(selectedFile && selectedFile.value && selectedFile.value.length > 0){
						$.get(reqUrl + '?path=' + currentPath + '&file=' + selectedFile.value + '&nfile=' + elmValue + '&m=' + Math.random(), exexCmdHdlr);
					}
				}
			}
		}
		else{
			alert(warnMsg);
		}
	}	
}
function exexCmdHdlr(xml){
	var res = $("s", xml).text();
	if(res){
		var elm = document.getElementById('dlgresult');
		if(res == 'Y'){
			if(executingCmd == 'delete'){
				elm.className = 'thirteen green bold';
				elm.innerHTML = 'Files deleted';
				addCloseBtn();
			}
			else{
				var txt = document.getElementById('cmdtxt');
				txt.disabled = false;
				elm.className = 'thirteen red bold';
				elm.innerHTML = 'A file with that name already exists';
				var btn = document.getElementById('cmdbtn');
				btn.disabled = false;
			}
		}
		else{
			elm.className = 'thirteen green bold';
			if(executingCmd == 'create'){
				elm.innerHTML = 'Folder created';
			}
			else{
				elm.innerHTML = 'Rename successful';
			}
			addCloseBtn();
		}
	}
}
function toggle(){
	var toggle = document.getElementById('toggle');
	var count = 0;
	while(true){
		var t = document.getElementById('toggle' + count);
		if(t){
			t.checked = toggle.checked;
			count++;
		}
		else{
			break;
		}
	}
}
function rename(){
	var count = 0;
	var found = 0;
	selectedIdx = -1;
	var resultOk = false;
	while(true){
		var t = document.getElementById('toggle' + count);
		if(t){
			if(t.checked){
				if(found < 1){
					found++;
					selectedIdx = count;
					resultOk = true;
				}
				else{
					alert('Please select only one item to rename');
					resultOk = false;
					break;
				}
			}
			count++;
		}
		else{
			break;
		}
	}
	
	if(found > 0){
		if(resultOk){
			showGray();
			setPopTitle('Rename item');
			clearChilds('popcont', null);
			var popCont = document.getElementById('popcont'); 
			popCont.innerHTML = generateDialogContentHtml('Please enter the desired item new name.', true);
			
			addCancelBtn('hideGray');
			addOkBtn('rename');
			var popDiv = document.getElementById('popdiv');
			popDiv.style.display = '';
		}
	}
	else{
		alert('Please select an item to rename');
	}
}
function delFiles(){
	selectedIndexes = new Array();
	var count = 0;
	while(true){
		var t = document.getElementById('toggle' + count);
		if(t){
			if(t.checked){
				selectedIndexes[selectedIndexes.length] = count;
			}
			count++;
		}
		else{
			break;
		}
	}
	if(selectedIndexes && selectedIndexes.length > 0){
		showGray();
		setPopTitle('Delete items');
		clearChilds('popcont', null);
		var popCont = document.getElementById('popcont'); 
		popCont.innerHTML = generateDialogContentHtml('Delete selected items?', false);
		
		addCancelBtn('hideGray');
		addOkBtn('delete');
		var popDiv = document.getElementById('popdiv');
		popDiv.style.display = '';
	}
	else{
		alert('Please select items to delete');
	}
}
function download(){
	selectedIndexes = new Array();
	var count = 0;
	while(true){
		var t = document.getElementById('toggle' + count);
		if(t){
			if(t.checked){
				selectedIndexes[selectedIndexes.length] = count;
			}
			count++;
		}
		else{
			break;
		}
	}
	if(selectedIndexes && selectedIndexes.length > 0){
		var fileStr = '';
		var selectedFile;
		var currentIndex = -1;
		for(var i=0; i<selectedIndexes.length; i++){
			currentIndex = selectedIndexes[i];
			selectedFile = document.getElementById('fname' + currentIndex);
			if(selectedFile && selectedFile.value && selectedFile.value.length > 0){
				if(i > 0){
					fileStr += encodeURIComponent('s/s');
				}
				fileStr += selectedFile.value;
			}
		}
		if(fileStr.length > 0){
			var fileNameUrl = '';
			var singleFile = false;
			if(selectedIndexes.length == 1){
				var fileType = document.getElementById('ftype' + currentIndex).value;
				if(fileType == 'f'){
					singleFile = true;
					fileNameUrl = fileStr;
				}
			}
			if(!singleFile){
				fileNameUrl = generateUpIdentifier() + '.zip';
			}
			var reqUrl = '/download/' + fileNameUrl + '?path=' + currentPath + '&files=' + fileStr + '&name=' + fileNameUrl + '&m=' + Math.random();
			window.open(reqUrl);
		}
	}
	else{
		alert('Please select items to download');
	}
}
function thumbs(thumbs){
	window.location.href= '/browse?path=' + currentPath + (curSortOrder != '' ? ('&sorder=' + curSortOrder) : '') + (curSortMethod != '' ? ('&sfield=' + curSortMethod) : '') + (thumbs == 'y' ? '&thumbs=y' : '');
}
